/* minish.c - example of a minimalistic shell 
 * Comments in code deliberately omitted. :-)
 *
 * [ Lainattu Kyttjrjestelmt -kurssille 2007 esimerkkin shellin
 *   perusideasta ja Unixin fork() -komennon kytst.
 * 
 *   Muokattu kevll 2014: siirretty komentomerkkijonon lukeminen
 *   omaan aliohjelmaansa, jotta pohjelma nyttisi selkemmlt.
 *
 *   Alkuperinen koodi on Tapani Tarvaisen kurssimateriaalista "UNIX
 *   ja shell-ohjelmointi". Tarkempia kommentteja koodissa ei ole,
 *   koska tm on Tapanin kurssin tehtvmateriaalia ja perinteinen
 *   tenttikysymys mys Kyttjrjestelmt -kurssilla
 *   (...kommentoimaton koodi annetaan, ja toiminta on
 *   selitettv). Trke kohta ovat fork() ja execve() -kutsut: mit
 *   ne tekevt, ja miten forkin paluuarvoa tulkitaan.
 *
 *   Terveisin Paavo 2007-06-05, 2014-04-01. ]
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/wait.h>
#define MAXLINE 30

int main(int argc, char **argv)
{
  char line[MAXLINE+1], *args[MAXLINE], *p, **arg;
  
  if (argc>=2 && !freopen(argv[1], "r", stdin)) {
    perror(argv[1]);
    exit(errno);
  }
  
  while (fgets(line, MAXLINE, stdin)) {
    if ((p = strchr(line, '\n'))) {
      *p=0; 
    } else { 
      fprintf(stderr, "line too long\n"); 
      exit(1); 
    }
    p = line;
    while (*p == ' ') 
      ++p;
    if (*p == '#') 
      continue;     
    *(arg=args) = p;           
    while ((p = strchr(p, ' '))) {
      while (*p == ' ') 
        *p++ = 0;
      if (*p) 
        *++arg=p;
    }
    *++arg=NULL;
    
    if (!strcmp(line,"exit")) {
      exit(args[1] ? atoi(args[1]) : 0);
    }
    
    switch (fork()) {
    case 0: 
      execvp(args[0], args);
      perror(args[0]);
      exit(errno);
    case -1: 
      perror("fork() failed");
      break;
    default: 
      wait(NULL);
    } 
  }
  
  exit(0);
}
